// automatically generated by the FlatBuffers compiler, do not modify

import * as flatbuffers from 'flatbuffers';

export class Profile {
  bb: flatbuffers.ByteBuffer|null = null;
  bb_pos = 0;
__init(i:number, bb:flatbuffers.ByteBuffer):Profile {
  this.bb_pos = i;
  this.bb = bb;
  return this;
}

static getRootAsProfile(bb:flatbuffers.ByteBuffer, obj?:Profile):Profile {
  return (obj || new Profile()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
}

static getSizePrefixedRootAsProfile(bb:flatbuffers.ByteBuffer, obj?:Profile):Profile {
  bb.setPosition(bb.position() + flatbuffers.SIZE_PREFIX_LENGTH);
  return (obj || new Profile()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
}

userId():string|null
userId(optionalEncoding:flatbuffers.Encoding):string|Uint8Array|null
userId(optionalEncoding?:any):string|Uint8Array|null {
  const offset = this.bb!.__offset(this.bb_pos, 4);
  return offset ? this.bb!.__string(this.bb_pos + offset, optionalEncoding) : null;
}

agentId():number {
  const offset = this.bb!.__offset(this.bb_pos, 6);
  return offset ? this.bb!.readFloat64(this.bb_pos + offset) : -1.0;
}

nationality():string|null
nationality(optionalEncoding:flatbuffers.Encoding):string|Uint8Array|null
nationality(optionalEncoding?:any):string|Uint8Array|null {
  const offset = this.bb!.__offset(this.bb_pos, 8);
  return offset ? this.bb!.__string(this.bb_pos + offset, optionalEncoding) : null;
}

fastLogin():boolean {
  const offset = this.bb!.__offset(this.bb_pos, 10);
  return offset ? !!this.bb!.readInt8(this.bb_pos + offset) : false;
}

userName():string|null
userName(optionalEncoding:flatbuffers.Encoding):string|Uint8Array|null
userName(optionalEncoding?:any):string|Uint8Array|null {
  const offset = this.bb!.__offset(this.bb_pos, 12);
  return offset ? this.bb!.__string(this.bb_pos + offset, optionalEncoding) : null;
}

static startProfile(builder:flatbuffers.Builder) {
  builder.startObject(5);
}

static addUserId(builder:flatbuffers.Builder, userIdOffset:flatbuffers.Offset) {
  builder.addFieldOffset(0, userIdOffset, 0);
}

static addAgentId(builder:flatbuffers.Builder, agentId:number) {
  builder.addFieldFloat64(1, agentId, -1.0);
}

static addNationality(builder:flatbuffers.Builder, nationalityOffset:flatbuffers.Offset) {
  builder.addFieldOffset(2, nationalityOffset, 0);
}

static addFastLogin(builder:flatbuffers.Builder, fastLogin:boolean) {
  builder.addFieldInt8(3, +fastLogin, +false);
}

static addUserName(builder:flatbuffers.Builder, userNameOffset:flatbuffers.Offset) {
  builder.addFieldOffset(4, userNameOffset, 0);
}

static endProfile(builder:flatbuffers.Builder):flatbuffers.Offset {
  const offset = builder.endObject();
  return offset;
}

static finishProfileBuffer(builder:flatbuffers.Builder, offset:flatbuffers.Offset) {
  builder.finish(offset);
}

static finishSizePrefixedProfileBuffer(builder:flatbuffers.Builder, offset:flatbuffers.Offset) {
  builder.finish(offset, undefined, true);
}

static createProfile(builder:flatbuffers.Builder, userIdOffset:flatbuffers.Offset, agentId:number, nationalityOffset:flatbuffers.Offset, fastLogin:boolean, userNameOffset:flatbuffers.Offset):flatbuffers.Offset {
  Profile.startProfile(builder);
  Profile.addUserId(builder, userIdOffset);
  Profile.addAgentId(builder, agentId);
  Profile.addNationality(builder, nationalityOffset);
  Profile.addFastLogin(builder, fastLogin);
  Profile.addUserName(builder, userNameOffset);
  return Profile.endProfile(builder);
}
}
